using System;
using NUnit.Framework;
using SharpTestsEx;

namespace NHibernate.Test.NHSpecificTest.QueryOverBadSql
{
    public class Fixture : BugTestCase
    {
        [Test]
        public void QueryOverComponentShouldNotFail()
        {
            using (var session = OpenSession())
            {
                var customer = new Customer
                {
                    Order = new Order { OrderDate = new DateTime(2010, 1, 1), Name = "TEST" }
                };

                var customer2 = new Customer1
                {
                    Order = new Order1 { OrderDate = new DateTime(2010, 1, 1) }
                };

                session.Save(customer);
                session.Save(customer2);

                session.Flush();

                Executing.This(
                    () => session.QueryOver<Customer1>().Where(o => o.Order == null).List())
                    .Should().NotThrow();

                Executing.This(
                    () => session.QueryOver<Customer>().Where(o => o.Order == null).List())
                    .Should().NotThrow();
            }
        }
    }
}